package com.winsun.auth.core.corsfilter;

import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

/**
 *
 *
 *
 * http://localhost:3000;
 * https://dx.dianyuanjiangli.com;
 * *ytx.21cn.com
 * *api.weixin.qq.com
 * *mp.weixin.qq.com
 * *open.weixin.qq.com
 * *mp.weixin.qq.com
 * *ismart.mini189.cn
 * *gzctpay.mini189.cn
 * *enter.gd189.cn
 * *icloud.mini189.cn
 * 14.116.225.*
 */
//@Configuration
public class CorsFilterConfig { //

    //@Bean
    public CorsFilter corsFilter() {
        final UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
        final CorsConfiguration config = new CorsConfiguration();
        // 允许cookies跨域
        config.setAllowCredentials(true);
        // 允许向该服务器提交请求的URI，*表示全部允许。。这里尽量限制来源域，比如http://xxxx:8080 ,以降低安全风险。。
        config.addAllowedOrigin("http://localhost:3000");
        config.addAllowedOrigin("https://dx.dianyuanjiangli.com");
        config.addAllowedOrigin("*ytx.21cn.com");
        config.addAllowedOrigin("*api.weixin.qq.com");
        config.addAllowedOrigin("*mp.weixin.qq.com");
        config.addAllowedOrigin("*open.weixin.qq.com");
        config.addAllowedOrigin("*mp.weixin.qq.com");
        config.addAllowedOrigin("*ismart.mini189.cn");
        config.addAllowedOrigin("*gzctpay.mini189.cn");
        config.addAllowedOrigin("*enter.gd189.cn");
        config.addAllowedOrigin("14.116.225.*");
        // 允许访问的头信息,*表示全部
        config.addAllowedHeader("*");
        // 预检请求的缓存时间（秒），即在这个时间段里，对于相同的跨域请求不会再预检了
        config.setMaxAge(18000L);
        // 允许提交请求的方法，*表示全部允许，也可以单独设置GET、PUT等
        config.addAllowedMethod("*");
        config.addAllowedMethod("HEAD");
        // 允许Get的请求方法
        config.addAllowedMethod("GET");
        config.addAllowedMethod("PUT");
        config.addAllowedMethod("POST");
        config.addAllowedMethod("DELETE");
        config.addAllowedMethod("PATCH");
        source.registerCorsConfiguration("/**", config);
        return new CorsFilter(source);
    }
}
